// host.cc
//
// The phind server program.  Accept requests for phind data 
// from STDIN and sed results to STDOUT.
// 
// Copyright 2000 Gordon Paynter (gwp@cs.waikato.ac.nz)

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include <vector.h>
#include <algo.h>

#include <TextGet.h>
#include <Terms.h>
#include <messages.h>

typedef unsigned int doccount;
typedef unsigned int phrasecount;


// The program itself reads request for phind data from STDIN,
// looks up the phrase's charatoristics in the mgpp files, and
// reports output to STDOUT.
//
// Interaction will ultimately take these forms:
//  XML  - outputs XML web pages that will berendered by other programs.
//  later: HTML - outputs web pages for use by CGI scripts

int main (int argc, char * argv[]) {

  // The filestem of the collection's phindex directory
  char basepath[FILENAME_MAX];
  char filename[FILENAME_MAX] = "phrase";

  // Command-line arguments
  // argv[1] is the collection directory
  // argv[2] is 
  if (argc < 2) {
    cerr << "Usage: " << argv[0] << " collection-directory [max-array-size]" << endl;
    exit(1);
  }
  strcpy(basepath, argv[1]);
  if (argc == 3) {
    
  } else {

  }


  // cout << "Creating textdata" << endl;
  TextData textData;
 
  // cout << "Loading textdata from: " <<  basepath << ", " << filename << endl;
  if (!textData.LoadData (basepath, filename)) {
    FatalError (1, "Couldn't load text information for \"%s\"", filename);
  }


  // Perform query
  // cout << "Performing query" << endl;

  // The "Level" of the entity to return (as a ML tag).
  UCArray docLevel;
  SetCStr (docLevel, "Document");

  // The document number
  unsigned long docNum = 0;

  // The array to store the result in
  UCArray docText;
  
  do {
    // cout << "Enter document number:" << endl;
    cin >> docNum;
    
    if (!GetDocText (textData, docLevel, docNum, docText)) {
      FatalError (1, "Error while trying to get document %u", docNum);
    }
    
    cout << docText;
  } while (docNum);

  // cout << "exit okay" << endl;
}
